Subject: Re: [Ace] Comments draft-palombini-ace-coap-pubsub-profile-04

From: Francesca Palombini <[email-masked]>
Date: Mon, 8 Jul 2019 14:35:03 +0000

Hi Marco,

Thanks a lot for this review! I finally managed to include your comments and update the document, and will be posting a new version soon. You can see the PR to this update here in the meantime: https://github.com/EricssonResearch/coap-pubsub-profile/pull/2 
Answers inline.

Thanks,
Francesca

On 09/04/2019, 10:18, "Ace on behalf of Marco Tiloca" <[email-masked] on behalf of [email-masked]> wrote:

    Hi,
    
    Please, find below some comments on this profile. I hope it helps!
    
    Best,
    /Marco
    
    ------------------------
    
    [Abstract]
    
    "This profile relies on transport layer or application layer security to
    authorize the publisher to the broker" is due to the current profiles of
    ACE, right? Otherwise, this can be (even) more general without
    mentioning particular layers.
    
FP: That is correct, that is due to what profile of ACE is used. I haven't made a change here.
    
    [Section 1]
    
    Here the claimed scope is authorizing nodes, but it is actually also
    about key provisioning (Section 3.1) and actual communication (Section 6.1).
    
FP: Right, I added some text about that.
    
    [Section 2]
    
    Here the claimed scope is protecting communication (in a broad sense),
    while it can again mention also authorizing nodes (as per ACE) and key
    provisioning (Section 3.1).

FP: Yes, added text about that as well.
    
    I believe that the paragraph "There are four phases, ..." and the
    numbered list would read better if placed right before the final
    paragraph "Note that AS1 and AS2 ..."
    
FP: I tried to make this change but could not split the numbered list from the following paragraph, since it talks about this exchange in particular, so I ended up not implementing this one. We can discuss more about this.
    
    [Section 3.1]
    
    I think this will also need a way for clients to agree with the AS2 on
    the correct format of their own public key (if they don't know already),
    similarly to what suggested in ace-key-groupcomm-oscore. The only type
    of approach that would not work is the one embedded with a Token POST,
    since that does not happen with AS2.

FP: Right, I now specified the optional key format negociation in the document. 
    
    The text says: "... the AS2 is both the AS and the KDC, ... so the
    Authorization Response and the Post Token message are not necessary" .
    Shouldn't we then have the Token POST to the KDC defined as optional
    already in ace-key-groupcomm ? See for instance its Figure 2.

FP: No, we do not need to change that in Key groupcomm, as that would be more complicated to motivate.
    
    In the Key Distribution Request, only one role can be indicated in
    scope. What if a client wants to be both publisher and subscriber? This
    seems allowed in Section 3.3 of core-coap-pubsub . Should a client
    separately contact the AS2 multiple times?
    
FP: Fixed that.

    In the Authorization Response, the 'profile' field can point at Section
    8.1 where the profile value is defined.

FP: Ok, done.
    
    In the Authorization Response, see above for the 'scope' field in case
    of a client that wants two roles.
    
FP: Yes, same.
    
    [Section 4]
    
    Page 8, second bullet point, it can say "... protect the publication
    end-to-end with the subscribers (see Section 6.1)".
    
FP: Ok, added
    
    [Section 5]
    
    Page 9, it can say "... keying material to verify the publication
    protected end-to-end with the publishers".

FP: Ok, added

    [Section 6]
    
    It would be good to refer to core-coap-pubsub , and its usage of Observe
    for subscriptions.

FP: Ok, added
    
    The text says: "The (F) message is ... , which is unprotected." ,
    although Section 3 admitted the possibility of communication secured
    also between Broker and Subscribers.
    
FP: that's right, I added some text about that.
    
    [Section 6.1]
    
    In the unprotected headers of the COSE object, what is used as Partial IV?
    
FP: I added something about this, although this probably requires more thinking.
    
    [Section 8.2]
    
    The value of 'Profile' should be "coap_pubsub' , consistently with the
    name of the profile registered in Section 8.1.

FP: Yes, this needed update.
    
    -- 
    Marco Tiloca
    Ph.D., Senior Researcher
    
    RISE Research Institutes of Sweden
    Division ICT
    Isafjordsgatan 22 / Kistagången 16
    SE-164 40 Kista (Sweden)
    
    Phone: +46 (0)70 60 46 501
    https://www.ri.se